// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.2.0
// - protoc             v4.23.4
// source: scenarioItem.proto

package proto

import (
	context "context"
	proto "gitlab.com/nikita.morozov/ms-shared/proto"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
	emptypb "google.golang.org/protobuf/types/known/emptypb"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// ScenarioItemClient is the client API for ScenarioItem service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type ScenarioItemClient interface {
	Create(ctx context.Context, in *ScenarioItemModel, opts ...grpc.CallOption) (*proto.IdRequest, error)
	Update(ctx context.Context, in *ScenarioItemModel, opts ...grpc.CallOption) (*emptypb.Empty, error)
	BatchUpdate(ctx context.Context, in *ScenarioItemBatch, opts ...grpc.CallOption) (*emptypb.Empty, error)
	Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error)
	Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ScenarioItemModel, error)
	List(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (ScenarioItem_ListClient, error)
}

type scenarioItemClient struct {
	cc grpc.ClientConnInterface
}

func NewScenarioItemClient(cc grpc.ClientConnInterface) ScenarioItemClient {
	return &scenarioItemClient{cc}
}

func (c *scenarioItemClient) Create(ctx context.Context, in *ScenarioItemModel, opts ...grpc.CallOption) (*proto.IdRequest, error) {
	out := new(proto.IdRequest)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioItem/Create", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioItemClient) Update(ctx context.Context, in *ScenarioItemModel, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioItem/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioItemClient) BatchUpdate(ctx context.Context, in *ScenarioItemBatch, opts ...grpc.CallOption) (*emptypb.Empty, error) {
	out := new(emptypb.Empty)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioItem/BatchUpdate", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioItemClient) Delete(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*proto.BoolValue, error) {
	out := new(proto.BoolValue)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioItem/Delete", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioItemClient) Get(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (*ScenarioItemModel, error) {
	out := new(ScenarioItemModel)
	err := c.cc.Invoke(ctx, "/botMs.ScenarioItem/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *scenarioItemClient) List(ctx context.Context, in *proto.IdRequest, opts ...grpc.CallOption) (ScenarioItem_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &ScenarioItem_ServiceDesc.Streams[0], "/botMs.ScenarioItem/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &scenarioItemListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type ScenarioItem_ListClient interface {
	Recv() (*ScenarioItemModel, error)
	grpc.ClientStream
}

type scenarioItemListClient struct {
	grpc.ClientStream
}

func (x *scenarioItemListClient) Recv() (*ScenarioItemModel, error) {
	m := new(ScenarioItemModel)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

// ScenarioItemServer is the server API for ScenarioItem service.
// All implementations must embed UnimplementedScenarioItemServer
// for forward compatibility
type ScenarioItemServer interface {
	Create(context.Context, *ScenarioItemModel) (*proto.IdRequest, error)
	Update(context.Context, *ScenarioItemModel) (*emptypb.Empty, error)
	BatchUpdate(context.Context, *ScenarioItemBatch) (*emptypb.Empty, error)
	Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error)
	Get(context.Context, *proto.IdRequest) (*ScenarioItemModel, error)
	List(*proto.IdRequest, ScenarioItem_ListServer) error
	mustEmbedUnimplementedScenarioItemServer()
}

// UnimplementedScenarioItemServer must be embedded to have forward compatible implementations.
type UnimplementedScenarioItemServer struct {
}

func (UnimplementedScenarioItemServer) Create(context.Context, *ScenarioItemModel) (*proto.IdRequest, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Create not implemented")
}
func (UnimplementedScenarioItemServer) Update(context.Context, *ScenarioItemModel) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}
func (UnimplementedScenarioItemServer) BatchUpdate(context.Context, *ScenarioItemBatch) (*emptypb.Empty, error) {
	return nil, status.Errorf(codes.Unimplemented, "method BatchUpdate not implemented")
}
func (UnimplementedScenarioItemServer) Delete(context.Context, *proto.IdRequest) (*proto.BoolValue, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Delete not implemented")
}
func (UnimplementedScenarioItemServer) Get(context.Context, *proto.IdRequest) (*ScenarioItemModel, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedScenarioItemServer) List(*proto.IdRequest, ScenarioItem_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedScenarioItemServer) mustEmbedUnimplementedScenarioItemServer() {}

// UnsafeScenarioItemServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to ScenarioItemServer will
// result in compilation errors.
type UnsafeScenarioItemServer interface {
	mustEmbedUnimplementedScenarioItemServer()
}

func RegisterScenarioItemServer(s grpc.ServiceRegistrar, srv ScenarioItemServer) {
	s.RegisterService(&ScenarioItem_ServiceDesc, srv)
}

func _ScenarioItem_Create_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioItemModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioItemServer).Create(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioItem/Create",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioItemServer).Create(ctx, req.(*ScenarioItemModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioItem_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioItemModel)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioItemServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioItem/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioItemServer).Update(ctx, req.(*ScenarioItemModel))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioItem_BatchUpdate_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(ScenarioItemBatch)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioItemServer).BatchUpdate(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioItem/BatchUpdate",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioItemServer).BatchUpdate(ctx, req.(*ScenarioItemBatch))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioItem_Delete_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioItemServer).Delete(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioItem/Delete",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioItemServer).Delete(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioItem_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(proto.IdRequest)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(ScenarioItemServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/botMs.ScenarioItem/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(ScenarioItemServer).Get(ctx, req.(*proto.IdRequest))
	}
	return interceptor(ctx, in, info, handler)
}

func _ScenarioItem_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(proto.IdRequest)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(ScenarioItemServer).List(m, &scenarioItemListServer{stream})
}

type ScenarioItem_ListServer interface {
	Send(*ScenarioItemModel) error
	grpc.ServerStream
}

type scenarioItemListServer struct {
	grpc.ServerStream
}

func (x *scenarioItemListServer) Send(m *ScenarioItemModel) error {
	return x.ServerStream.SendMsg(m)
}

// ScenarioItem_ServiceDesc is the grpc.ServiceDesc for ScenarioItem service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var ScenarioItem_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "botMs.ScenarioItem",
	HandlerType: (*ScenarioItemServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Create",
			Handler:    _ScenarioItem_Create_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _ScenarioItem_Update_Handler,
		},
		{
			MethodName: "BatchUpdate",
			Handler:    _ScenarioItem_BatchUpdate_Handler,
		},
		{
			MethodName: "Delete",
			Handler:    _ScenarioItem_Delete_Handler,
		},
		{
			MethodName: "Get",
			Handler:    _ScenarioItem_Get_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _ScenarioItem_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "scenarioItem.proto",
}
